/**
 * Copyright (C) 2010 Cloudfarming <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.area.plot;

import com.vividsolutions.jts.geom.MultiPolygon;
import nl.cloudfarming.client.geoviewer.LayerObject;

/**
 *
 * @author Timon Veenstra
 */
public class ShapeLayerObject implements LayerObject<MultiPolygon, Shape> {

    private final Shape shape;

    public ShapeLayerObject(Shape shape) {
        this.shape = shape;
    }

    @Override
    public Shape getObject() {
        return this.shape;
    }

    @Override
    public MultiPolygon getGeometry() {
        return this.shape.getGeometry();
    }

    @Override
    public String getKey() {
        return Long.toString(this.shape.getId());
    }

    @Override
    public Object getKeyAttributeValue() {
        return shape.getName();
    }

    @Override
    public String getTooltipText() {
        return Long.toString(this.shape.getId()) + " " + this.shape.getName();
    }

    @Override
    public Long getId() {
        return this.shape.getId();
    }

//    @Override
//    public Sheet createSheet() {
//
//        Sheet sheet = Sheet.createDefault();
//        Sheet.Set set = Sheet.createPropertiesSet();
//
//        try {
//
//            Property idProp = new PropertySupport.Reflection(this.shape, Long.class, "getId", null);
//            Property nameProp = new PropertySupport.Reflection(this.shape, String.class, "getName", null);
//
//            idProp.setName("id");
//            nameProp.setName("name");
//
//            set.put(idProp);
//            set.put(nameProp);
//
//        } catch (NoSuchMethodException ex) {
//            Exceptions.printStackTrace(ex);
//        }
//
//        sheet.put(set);
//        return sheet;
//    }
}
